﻿
@{
                /**/

                ViewBag.Title = "Index";
}

<style type="text/css">
    .true {
        color: black;
    }

    .false {
        color: red;
    }
</style>

<div class="row">
    <div class="col-md-12">
        <section class="block">
            <div class="block-header">
                <h3 class="block-title">Cat&aacute;logo Contable</h3>
                <div class="block-options">
                    <a href="../Home/Index/" class="btn btn-sm btn-secondary"><span class="fa fa-arrow-left"></span> Atr&aacute;s...</a>
                    <button type="button" class="btn btn-sm btn-success" data-toggle="modal" data-target="#myModal"><span class="fa fa-plus"></span> Nuevo</button>
                    <button type="button" class="btn btn-sm btn-warning" onclick="fnReload()" ><span class="fa fa-refresh"></span> Recargar</button>
                    <button type="button" class="btn-block-option" data-toggle="block-option" data-action="content_toggle"></button>
                </div>                
            </div>

            <div class="block-content">
                <div class="table-responsive">
                    <table id="tbAccounts" class="table table-bordered table-striped table-vcenter">
                        <thead>
                            <tr>
                                <th width="60">Id</th>
                                <th width="100">Cadena Contable</th>
                                <th width="50%">Nombre</th>
                                <th width="40" class="numeric">Nivel</th>
                                <th width="60">Padre</th>
                                <th width="40">Opciones</th>
                            </tr>
                        </thead>
                        <tbody></tbody>
                    </table>

                </div>

            </div>

</section>
    </div>
</div>

<div aria-hidden="true" aria-labelledby="myModalLabel" role="dialog" tabindex="-1" id="myModal" class="modal fade">
    <div class="modal-dialog modal-dialog-popout" role="document">
        <div class="modal-content">
            <div class="block block-themed block-transparent mb-0">
                <div class="block-header bg-primary-dark">
                    <h3 class="block-title">Crear Cuenta</h3>
                    <div class="block-options">
                        <button type="button" class="btn-block-option" data-dismiss="modal" aria-label="Close">
                            <i class="fa fa-fw fa-times"></i>
                        </button>
                    </div>
                </div>
            </div>
            <div class="block-content font-size-sm">
                <form role="form">
                    <div class="form-group">
                        <label for="accountChain">Cadena Contable</label>
                        <input type="text" class="form-control" id="accountChain" placeholder="Cadena Contable">
                    </div>

                    <div class="form-group">
                        <label for="name">Nombre</label>
                        <input type="text" class="form-control" id="name" placeholder="Nombre">
                    </div>

                    <div class="form-group">
                        <label for="level">Nivel</label>
                        <input type="number" class="form-control" id="level" placeholder="Nivel">
                    </div>

                    <div class="form-group">
                        <label for="parentAccount">Cuenta Padre</label>
                        <input type="number" class="form-control" id="parentAccount" placeholder="Cuenta Padre">
                    </div>
                    
                </form>

            </div>
            <div class="block-content block-content-full text-right border-top">
                <button id="btnEditSave" type="button" class="btn btn-sm btn-success" onclick="fnNewAccount()"><i class="fa fa-check mr-1"></i>Guardar</button>
            </div>
        </div>

           
    </div>    
</div>


<div aria-hidden="true" aria-labelledby="myModalLabel" role="dialog" tabindex="-1" id="EditModal" class="modal fade">
    <div class="modal-dialog modal-dialog-popout" role="document">
        <div class="modal-content">
            <div class="block block-themed block-transparent mb-0">
                <div class="block-header bg-primary-dark">
                    <h3 class="block-title">Editar Cuenta</h3>
                    <div class="block-options">
                        <button type="button" class="btn-block-option" data-dismiss="modal" aria-label="Close">
                            <i class="fa fa-fw fa-times"></i>
                        </button>
                    </div>
                </div>
                <div class="block-content font-size-sm">
                    <form role="form">

                        <div class="form-group">
                            <label for="idEdit">Id</label>
                            <input type="text" class="form-control" id="idEdit" placeholder="Id" disabled>
                        </div>

                        <div class="form-group">
                            <label for="accountChainEdit">Cadena Contable</label>
                            <input type="text" class="form-control" id="accountChainEdit" placeholder="Cadena Contable">
                        </div>

                        <div class="form-group">
                            <label for="nameEdit">Nombre</label>
                            <input type="text" class="form-control" id="nameEdit" placeholder="Nombre">
                        </div>

                        <div class="form-group">
                            <label for="levelEdit">Nivel</label>
                            <input type="number" class="form-control" id="levelEdit" placeholder="Nivel">
                        </div>

                        <div class="form-group">
                            <label for="parentAccountEdit">Cuenta Padre</label>
                            <input type="number" class="form-control" id="parentAccountEdit" placeholder="Cuenta Padre">
                        </div>
                        
                    </form>
                </div>
                <div class="block-content block-content-full text-right border-top">
                    <button id="btnEditSave" type="button" class="btn btn-sm btn-success" onclick="fnUpdateAccount()"><i class="fa fa-check mr-1"></i>Guardar</button>
                </div>
            </div>
        </div>
    </div>
</div>


@section Scripts {
    <script type="text/javascript">
        var _accounts = [];


        function fnLoadAccount() {
            var url = "../Account/GetAccounts";
            _accounts = [];
            //var filter = {};
            /*
            filter.EventType = _tipo;
            filter.Year = myDate.getUTCFullYear();
            filter.Month = myDate.getUTCMonth() + 1;
            filter.Day = myDate.getUTCDate();
            filter.LastId = _lastId;
            filter.FirstId = 0;
            */
            var batchLenght = 0;
            var counter = 0;
            var line = "";
            $("#tbAccounts tbody").empty();

            $.ajax({
                type: "GET",
                data: {},//{ ProjectID: p },
                url: url,
                success: function (data) {
                    if (data.Type == "E") {
                        toastr.error(data.Message, 'Error', { closeButton: true });
                        return false;
                    }
                    else {
                        batchLenght = data.Info.length;
                        _accounts = data.Info;
                        
                        $.each(data.Info, function (key, value) {
                            line = "";
                            line = "<tr class='" + value.Active + "'><td>" + value.Id + "</td><td>" + value.AccountingChain + "</td><td>" + value.Name + "</td><td class='numeric'>" + value.Level + "</td><td>" + value.ParentId + "</td><td>";
                            if (value.Active) {
                                line = line + "<span class='btn-group'>";
                                line = line + "<button class='btn btn-sm btn-primary' title='Editar' type='button' data-toggle='modal' data-target='#EditModal' ";
                                line = line + "onclick = 'fnLoadEdit(" + value.Id + ")' > ";
                                line = line + "<span class='fa fa-fw fa-pencil'></span></button>";
                                line = line + "<button class='btn btn-sm btn-primary' title='Eliminar' type='button' onclick='fnDelete(" + value.Id + ")'><span class='fa fa-fw fa-times'></span></button></span>";
                            }
                            else {
                                line = line + " ";
                            }
                            
                            line = line + "</td></tr>"
                            $("#tbAccounts tbody").append(line);                            
                            counter++;
                        });
                    }
                }
            });


        }

        function fnNewAccount() {
            var Url = "../Account/AddNewAccount";
            var param = {};
            param.Id = "0";
            param.AccountingChain = $('#accountChain').val();
            param.Name = $('#name').val();
            param.Level = $('#level').val();
            param.ParentId = $('#parentAccount').val();


            $.ajax({
                url: (Url),
                type: "POST",
                async: false,
                data: '{param:' + JSON.stringify(param) + '}',
                dataType: "json",
                contentType: "application/json; charset=utf-8",
                success: function (data) {
                    if (data.Type == "E") {
                        toastr.error(data.Message, 'Error');
                        return false;
                    }
                    else {
                        toastr.success('Cuenta guardada correctamente.', 'Exitoso');
                        fnLoadAccount();
                    }
                },
                error: function (result) {
                    toastr.error('Se produjo un error inesperado', 'Error');
                }
            });
        }

        function fnReload() {
            location.reload(true);
        }

        function fnLoadEdit(id) {            
            $.each(_accounts, function (key, value) {
                if (value.Id == id) {
                    $("#idEdit").val(value.Id);
                    $("#accountChainEdit").val(value.AccountingChain);
                    $("#nameEdit").val(value.Name);
                    $("#levelEdit").val(value.Level);
                    $("#parentAccountEdit").val(value.ParentId);
                }
            });
        }

        function fnUpdateAccount() {
            var Url = "../Account/UpdateAccount";
            var param = {};
            param.Id = $('#idEdit').val();
            param.AccountingChain = $('#accountChainEdit').val();
            param.Name = $('#nameEdit').val();
            param.Level = $('#levelEdit').val();
            param.ParentId = $('#parentAccountEdit').val();

            $.ajax({
                url: (Url),
                type: "POST",
                async: false,
                data: '{param:' + JSON.stringify(param) + '}',
                dataType: "json",
                contentType: "application/json; charset=utf-8",
                success: function (data) {
                    if (data.Type == "E") {
                        toastr.error(data.Message, 'Error');
                        return false;
                    }
                    else {
                        toastr.success('Cuenta guardada correctamente.', 'Exitoso');
                        fnLoadAccount();
                    }
                },
                error: function (result) {
                    toastr.error('Se produjo un error inesperado', 'Error');
                }
            });
        }

        function fnDelete(id) {
            var Url = "../Account/DeleteAccount";
            var param = {};
            $.each(_accounts, function (key, value) {
                if (value.Id == id) {                    
                    param.Id = id;
                    param.AccountingChain = value.AccountingChain;
                    param.Name = value.Name;
                    param.Level = value.Level;
                    param.ParentId = value.ParentId;
                }
            });
            
            $.ajax({
                url: (Url),
                type: "POST",
                async: false,
                data: '{param:' + JSON.stringify(param) + '}',
                dataType: "json",
                contentType: "application/json; charset=utf-8",
                success: function (data) {
                    if (data.Type == "E") {
                        toastr.error(data.Message, 'Error');
                        return false;
                    }
                    else {
                        toastr.success('Cuenta eliminada correctamente.', 'Exitoso');
                        fnLoadAccount();
                    }
                },
                error: function (result) {
                    toastr.error('Se produjo un error inesperado', 'Error');
                }
            });
        }

        fnLoadAccount();





    </script>

    @Scripts.Render("~/bundles/jqueryval")
}